averageTraffic = {}
averageTraffic.modDir = g_currentModDirectory

TrafficSystem.onCreate = Utils.overwrittenFunction(TrafficSystem.onCreate, function (self, superFunc, transformId)
    local xmlFilename = getUserAttribute(transformId, "xmlFile")

    local mod = g_modManager:getModByName("FS22_RussianLicensePlates")
    if mod ~= nil and g_modIsLoaded["FS22_RussianLicensePlates"] then
        prefix = "rus"
    else
        prefix = "ukr"
    end

    if xmlFilename ~= nil then
        local randomTraffic = math.random(1, 3)
        local randomFilename = string.format("data/trafficSystem%s_%s.xml", randomTraffic, prefix)
        xmlFilename = Utils.getFilename(randomFilename, averageTraffic.modDir)
        if randomTraffic == 1 then
            randomTraffic2 = 5
            randomTraffic3 = 6
        elseif randomTraffic == 2 then
            randomTraffic2 = 4
            randomTraffic3 = 6
        elseif randomTraffic == 3 then
            randomTraffic2 = 4
            randomTraffic3 = 5
        end
        local randomFilename2 = string.format("data/trafficSystem%s_%s.xml", randomTraffic2, prefix)
        local randomFilename3 = string.format("data/trafficSystem%s_%s.xml", randomTraffic3, prefix)
        xmlFilename2 = Utils.getFilename(randomFilename2, averageTraffic.modDir)
        xmlFilename3 = Utils.getFilename(randomFilename3, averageTraffic.modDir)
        local lightsProfile = g_gameSettings:getValue("lightsProfile")
        local useHighProfile = lightsProfile == GS_PROFILE_HIGH or lightsProfile == GS_PROFILE_VERY_HIGH
        local trafficSystem = TrafficSystem.new(g_server ~= nil, g_client ~= nil)
        local trafficSystem2 = TrafficSystem.new(g_server ~= nil, g_client ~= nil)
        local trafficSystem3 = TrafficSystem.new(g_server ~= nil, g_client ~= nil)

        if trafficSystem:load(xmlFilename, transformId, useHighProfile, g_server ~= nil, g_client ~= nil) then
            trafficSystem:register(true)
            g_currentMission.onCreateObjectSystem:add(trafficSystem)
            trafficSystem:setEnabled(g_currentMission.missionInfo.trafficEnabled)
            print("Base trafficSystem xml is "..tostring(xmlFilename).."!")
        else
            trafficSystem:delete()
        end

        if trafficSystem2:load(xmlFilename2, transformId, useHighProfile, g_server ~= nil, g_client ~= nil) then
            trafficSystem2:register(true)
            g_currentMission.onCreateObjectSystem:add(trafficSystem2)
            trafficSystem2:setEnabled(g_currentMission.missionInfo.trafficEnabled)
            print("First additional trafficSystem xml is "..tostring(xmlFilename2).."!")
        else
            trafficSystem2:delete()
        end

        if trafficSystem3:load(xmlFilename3, transformId, useHighProfile, g_server ~= nil, g_client ~= nil) then
            trafficSystem3:register(true)
            g_currentMission.onCreateObjectSystem:add(trafficSystem3)
            trafficSystem3:setEnabled(g_currentMission.missionInfo.trafficEnabled)
            print("Second additional trafficSystem xml is "..tostring(xmlFilename3).."!")
        else
            trafficSystem3:delete()
        end

        g_currentMission.trafficSystem = trafficSystem and trafficSystem2 and trafficSystem3
    else
        print("Error: Missing xmlFile attribute for traffic system in " .. getName(transformId))
    end
end)